<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/class.ds-vector.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'ru',
  ),
  'this' => 
  array (
    0 => 'ds-vector.filter.php',
    1 => 'Ds\\Vector::filter',
  ),
  'up' => 
  array (
    0 => 'class.ds-vector.php',
    1 => 'Ds\\Vector',
  ),
  'prev' => 
  array (
    0 => 'ds-vector.count.php',
    1 => 'Ds\\Vector::count',
  ),
  'next' => 
  array (
    0 => 'ds-vector.find.php',
    1 => 'Ds\\Vector::find',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'ru',
    'path' => 'reference/ds/ds/vector/filter.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="ds-vector.filter" class="refentry">
 <div class="refnamediv">
  <h1 class="refname">Ds\Vector::filter</h1>
  <p class="verinfo">(PECL ds &gt;= 1.0.0)</p><p class="refpurpose"><span class="refname">Ds\Vector::filter</span> &mdash; <span class="dc-title">
   Создаёт новый вектор из элементов, выбранных с помощью заданной callback-функции
  </span></p>

 </div>

 <div class="refsect1 description" id="refsect1-ds-vector.filter-description">
  <h3 class="title">Описание</h3>
  <div class="methodsynopsis dc-description">
   <span class="modifier">public</span> <span class="methodname"><strong>Ds\Vector::filter</strong></span>(<span class="methodparam"><span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span> <code class="parameter">$callback</code><span class="initializer"> = ?</span></span>): <span class="type"><a href="class.ds-vector.php" class="type Ds\Vector">Ds\Vector</a></span></div>

  <p class="para rdfs-comment">
   Создаёт новый вектор из элементов, выбранных с помощью заданной callback-функции.
  </p>
 </div>


 <div class="refsect1 parameters" id="refsect1-ds-vector.filter-parameters">
  <h3 class="title">Список параметров</h3>
  <dl>

   
    <dt><code class="parameter">callback</code></dt>

    <dd>
     <p class="para">
      <div class="methodsynopsis dc-description"><span class="methodname"><span class="replaceable">callback</span></span>(<span class="methodparam"><span class="type"><a href="language.types.mixed.php" class="type mixed">mixed</a></span> <code class="parameter">$value</code></span>): <span class="type"><a href="language.types.boolean.php" class="type bool">bool</a></span></div>

     </p>
     <p class="para">
      Опциональный аргумент типа <span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span>, который возвращает <strong><code><a href="reserved.constants.php#constant.true">true</a></code></strong>, если
      значение должно быть включено и <strong><code><a href="reserved.constants.php#constant.false">false</a></code></strong>, если нет.
     </p>
     <p class="para">
      Если callback-функция не задана, то будут включены только элементы, которые
      приводятся к логическому значению <strong><code><a href="reserved.constants.php#constant.true">true</a></code></strong>
      (смотрите <a href="language.types.boolean.php#language.types.boolean.casting" class="link">приведение к boolean</a>).
     </p>
    </dd>

   
  </dl>
 </div>


 <div class="refsect1 returnvalues" id="refsect1-ds-vector.filter-returnvalues">
  <h3 class="title">Возвращаемые значения</h3>
  <p class="para">
   Новый вектор, содержащий значения, для которых функция
   <code class="parameter">callback</code> вернула <strong><code><a href="reserved.constants.php#constant.true">true</a></code></strong>, либо все элементы, которые при
   приведении к логическому типу становятся <strong><code><a href="reserved.constants.php#constant.true">true</a></code></strong>, если параметр
   <code class="parameter">callback</code> не задан.
  </p>
 </div>


 <div class="refsect1 examples" id="refsect1-ds-vector.filter-examples">
  <h3 class="title">Примеры</h3>
  <div class="example" id="example-4171">
   <p><strong>Пример #1 Пример <span class="function"><strong>Ds\Vector::filter()</strong></span> с использованием callback-функции</strong></p>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$vector </span><span style="color: #007700">= new </span><span style="color: #0000BB">\Ds\Vector</span><span style="color: #007700">([</span><span style="color: #0000BB">1</span><span style="color: #007700">, </span><span style="color: #0000BB">2</span><span style="color: #007700">, </span><span style="color: #0000BB">3</span><span style="color: #007700">, </span><span style="color: #0000BB">4</span><span style="color: #007700">, </span><span style="color: #0000BB">5</span><span style="color: #007700">]);<br /><br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$vector</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">filter</span><span style="color: #007700">(function(</span><span style="color: #0000BB">$value</span><span style="color: #007700">) {<br />    return </span><span style="color: #0000BB">$value </span><span style="color: #007700">% </span><span style="color: #0000BB">2 </span><span style="color: #007700">== </span><span style="color: #0000BB">0</span><span style="color: #007700">;<br />}));<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   
<div class="example-contents"><p>
 Вывод приведённого примера будет похож на:
</p></div>

   <div class="example-contents screen">
<div class="examplescode"><pre class="examplescode">object(Ds\Vector)#3 (2) {
  [0]=&gt;
  int(2)
  [1]=&gt;
  int(4)
}</pre>
</div>
   </div>
  </div>
  <div class="example" id="example-4172">
   <p><strong>Пример #2 Пример <span class="function"><strong>Ds\Vector::filter()</strong></span> без callback-функции</strong></p>
   <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br />$vector </span><span style="color: #007700">= new </span><span style="color: #0000BB">\Ds\Vector</span><span style="color: #007700">([</span><span style="color: #0000BB">0</span><span style="color: #007700">, </span><span style="color: #0000BB">1</span><span style="color: #007700">, </span><span style="color: #DD0000">'a'</span><span style="color: #007700">, </span><span style="color: #0000BB">true</span><span style="color: #007700">, </span><span style="color: #0000BB">false</span><span style="color: #007700">]);<br /><br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$vector</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">filter</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
   </div>

   
<div class="example-contents"><p>
 Вывод приведённого примера будет похож на:
</p></div>

   <div class="example-contents screen">
<div class="examplescode"><pre class="examplescode">object(Ds\Vector)#2 (3) {
  [0]=&gt;
  int(1)
  [1]=&gt;
  string(1) &quot;a&quot;
  [2]=&gt;
  bool(true)
}</pre>
</div>
   </div>
  </div>
 </div>



</div><?php manual_footer($setup); ?>